# coding: utf-8
"""
    DOJAH APIs

    Use Dojah to verify, onboard and manage user identity across Africa!

    The version of the OpenAPI document: 1.0.0
    Generated by: https://konfigthis.com
"""

import typing
import inspect
from datetime import date, datetime
from dojah_client.client_custom import ClientCustom
from dojah_client.configuration import Configuration
from dojah_client.api_client import ApiClient
from dojah_client.type_util import copy_signature
from dojah_client.apis.tags.aml_api import AMLApi
from dojah_client.apis.tags.authentication_api import AuthenticationApi
from dojah_client.apis.tags.financial_api import FinancialApi
from dojah_client.apis.tags.ghkyc_api import GHKYCApi
from dojah_client.apis.tags.general_api import GeneralApi
from dojah_client.apis.tags.kekyc_api import KEKYCApi
from dojah_client.apis.tags.kyb_api import KYBApi
from dojah_client.apis.tags.kyc_api import KYCApi
from dojah_client.apis.tags.ml_api import MLApi
from dojah_client.apis.tags.services_api import ServicesApi
from dojah_client.apis.tags.ugkyc_api import UGKYCApi
from dojah_client.apis.tags.wallet_api import WalletApi
from dojah_client.apis.tags.web_hooks_api import WebHooksApi



class Dojah(ClientCustom):

    def __init__(self, configuration: typing.Union[Configuration, None] = None, **kwargs):
        super().__init__(configuration, **kwargs)
        if (len(kwargs) > 0):
            configuration = Configuration(**kwargs)
        if (configuration is None):
            raise Exception("configuration is required")
        api_client = ApiClient(configuration)
        self.aml: AMLApi = AMLApi(api_client)
        self.authentication: AuthenticationApi = AuthenticationApi(api_client)
        self.financial: FinancialApi = FinancialApi(api_client)
        self.gh_kyc: GHKYCApi = GHKYCApi(api_client)
        self.general: GeneralApi = GeneralApi(api_client)
        self.ke_kyc: KEKYCApi = KEKYCApi(api_client)
        self.kyb: KYBApi = KYBApi(api_client)
        self.kyc: KYCApi = KYCApi(api_client)
        self.ml: MLApi = MLApi(api_client)
        self.services: ServicesApi = ServicesApi(api_client)
        self.ug_kyc: UGKYCApi = UGKYCApi(api_client)
        self.wallet: WalletApi = WalletApi(api_client)
        self.web_hooks: WebHooksApi = WebHooksApi(api_client)
